#pragma once
#include "WinSDKVer.h"
#define _WIN32_WINNT _WIN32_WINNT_WIN7
#include "dXManager.h"
#include "triangleObject.h"
#include "colorShaderRenderer.h"

static const short kWidth  = 800;
static const short kHeight = 600;
static const TCHAR *kTitle = L"C++ and DirectX 11";
static const TCHAR *kWindowClass = L"win32app";

class Core
{
public:
	Core();
	int  Run(void);
	bool Initialize(void);
	void Shutdown(void);
	LRESULT CALLBACK MessageHandler(HWND, UINT, WPARAM, LPARAM);
private:
	bool _isRunning;
	HWND _hwnd;
	HINSTANCE _hinst;
	DXManager *_DXManager;
	TriangleObject *_triangle;
	ColorShaderRenderer *_colorShaderRenderer;
	bool CreateMainWindow(void);
	void DestroyMainWindow(void);
	void OnFrameRender(void);
};

static Core *kCoreHandle = nullptr;
static LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
